name: Check master code
on:
  push:
    branches:
      - master

jobs:
  coverage:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v4
        with:
          fetch-depth: 0
      - name: Fetch tags
        run: git fetch --tags -p
      - uses: KengoTODA/actions-setup-docker-compose@v1
        with:
          version: "2.23.3"
      - name: run selfoss
        run: |
          docker compose -f .gitea/workflows/assets/docker-compose.yml up -d
      - uses: actions/setup-java@v4
        with:
          distribution: 'temurin'
          java-version: '17'
          cache: gradle
      - uses: gradle/actions/setup-gradle@v3
      - uses: android-actions/setup-android@v3
      - name: Configure gradle...
        run: mkdir -p ~/.gradle && echo "org.gradle.daemon=false\nignoreGitVersion=true" >> ~/.gradle/gradle.properties
      - name: coverage
        run: |
          ./gradlew :koverHtmlReport
      - uses: actions/upload-artifact@v3
        with:
          name: coverage
          path: build/reports/kover/html
          retention-days: 1
          overwrite: true
          include-hidden-files: true
      - name: Clean
        if: always()
        run: |
          docker compose -f .gitea/workflows/assets/docker-compose.yml stop